jQWidgets
=========

jQWidgets is an advanced UI framework for Angular, React, Vue, Web Components, Javascript and ASP .NET.

![Angular Components](https://www.jqwidgets.com/wp-content/images/material-pager.png)

What is jQWidgets?
---------

jQWidgets represents a framework based on Javascript for building web-based applications that run on PC, Touch and Mobile devices. jQWidgets includes more than 60 User Interface widgets. All UI widgets are designed from ground-up and based on a powerful common core. The framework core provides fundamental capabilities like support for widget extensions and inheritance, widget settings, internal event handling and routing, property change notifications, device and browser compatibility detection and adjustments.

Highlights
---------
* Feature complete User Interface widgets.
* Works on PC, Touch and Mobile Devices.
* Rich functionality and great performance.
* Web Components built from ground-up.
* React Javascript Library User Interface Components
* Angular and AngularJS 1.x Directives for every widget.
* ASP .NET Core UI Components
* Easy PHP & ASP .NET integration and how-to demos.
* Typescript Definitions for all widgets.
* PhoneGap Integration.
* Java Integration.
* 60+ UI components, 30+ Charts, 1000+ code samples are provided to accelerate your learning.
* Search-engine friendly.
* Guaranteed 24h support time for licensed developers Mon-Fri.
* Outstanding technical assistance provided by software developers.
* Free fully functional Download and upgrades for a full calendar year.
* [Chart Studio](https://www.jqwidgets.com/chartstudio/) - cloud solution for visual editing and hosting of interactive charts.
* [jsEditor](https://www.jqwidgets.com/jseditor/) - cloud solution for JavaScript, HTML and CSS editing, hosting and sharing your web development ideas.
* Easy CSS styling and [Online Theme Builder](https://www.jqwidgets.com/themebuilder).
* Ready to use, built-in Themes.
* Unique and completely customizable architecture for JQuery widgets.
* Integration tutorials for Bootstrap, RequireJS, BreezeJS, KnockoutJS.
* jQuery Mobile, WordPress, Joomla and more.

Works across devices and browsers
---------

jQWidgets takes the JavaScript & HTML UI development to a new level. It is platform independent, cross-browser compatible and works on PC and mobile devices. Don’t spend time testing on different devices and browsers. Use a reliable, CSS compliant JavaScript library based jQuery, HTML5 and CSS3.The product supports all major desktop and mobile web browsers - Internet Explorer 7.0+, Firefox 2.0+, Safari 3.0+, Opera 9.0+, Google Chrome, IE Mobile, Android, Opera Mini, Mobile Safari(IPhone, IPad).

Licensing
---------

*Non-Commercial License*

Do you want to use jQWidgets for a non-profit project? Then you can use jQWidgets for free under the Creative Commons Attribution-NonCommercial 3.0 License.

* For non-profit organizations, public schools and non-commercial personal websites.
* For testing applications using jQWidgets.

You are allowed to distribute jQWidgets with non-commercial packages given that you fulfill two conditions:

* Emphasize to your users that jQWidgets is not free for commercial use. You can do this on your download page or when your users activate jQWidgets in your application.
* Provide a link back to this web page in the same location: https://www.jqwidgets.com/license/.

*Commercial License*

The commercial license is suitable for commercial websites and projects or a corporate intranet. The license is perpetual and allows royalty free distribution with your websites and applications. Each license includes 1-year subscription for free product updates and platinum, premium or standard technical support plan. Subscription renewal is optional and costs 50% of the price of a new license. For subscription renewals, license upgrades, licenses with more than 1-year subscription or if you wish to license subsidiary or affiliate organizations, please contact us.

For more information, please visit https://www.jqwidgets.com/license/.

More
-
* React Demos: https://www.jqwidgets.com/react/
* Angular Demos: https://www.jqwidgets.com/angular/
* ASP .NET Core Demos: https://www.jqwidgets.com/asp.net-core-mvc-tag-helpers/
* Showcase Demos: https://www.jqwidgets.com/jquery-widgets-demo/showcasedemos/
* Javascript/jQuery Demos: https://www.jqwidgets.com/jquery-widgets-demo/
* Web Components Demos: https://www.htmlelements.com/
* Services: https://www.jqwidgets.com/services/
* Community Forums: https://www.jqwidgets.com/community/
